package cn.zyjblogs.design.singleton;

/**
 * 懒汉式
 * 虽然也能达到按需初始化的目的，但却带来了线程不安全问题
 */
public class Mgr04 {
    private static Mgr04 INSTANCE;
    private Mgr04() {
    }
    /**
     * 线程安全,但是要上锁，效率降低了
     * @return
     */
    public static synchronized Mgr04 getInstance(){
        if (INSTANCE == null){
            try {
                Thread.sleep(1);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            INSTANCE = new Mgr04();
        }
        return INSTANCE;
    }

    public void m(){
        System.out.println("m");
    }

    public static void main(String[] args) {
        for (int i = 0; i < 100; i++) {
            new Thread(()->{
                System.out.println(Mgr04.getInstance().hashCode());
            }).start();
        }
    }
}
